use std::fs;
use std::io::prelude::*;
use std::net::TcpListener;
use std::net::TcpStream;

fn main() {
    let listener = TcpListener::bind("127.0.0.1:3000").unwrap();

    for stream in listener.incoming() {
        let stream = stream.unwrap();
        handle_connection(stream);
    }
}

fn handle_connection(mut stream: TcpStream) {
    let mut buffer = [0; 1024];

    stream.read(&mut buffer).unwrap();

    let hostname = "localhost";
    let path = "/";
    let post = "\r\n";
    
    /*
    let get = format!(
        "{} {} {} {}",
        hostname,
        path,
        post.len(),
        post
    );*/

    let get = b"127.0.0.1 / 0\r\n";

    if buffer.starts_with(get) {
        let contents = fs::read_to_string("index.gmi").unwrap();
        let status = 2;
        let meta = "text/gemini";
        let response = format!(
            "{} {}\r\n{}",
            status,
            meta,
            contents
        );

        stream.write(response.as_bytes()).unwrap();
        stream.flush().unwrap();
    } else {
        let status_line = "4 Not Found";

        stream.write(status_line.as_bytes()).unwrap();
        stream.flush().unwrap();
    }


    
}
